%clear all;
load 'fricData.mat';
% Find the pressure curve

i = [1615; %indexes in data
     1680;
     1770;
     1848;
     1929;
     2008;
     2154;
     2220;
     2306;
     2404;
     2498;
     2575;
     2651;
     2721;
     2802;
     2868;
     2957;
     3005;
     3157;
     3228;
     3314;
     3408;
     3524;
     3620;
     3712;
     3851;
     3977;
     4097;
     4219;
     4325;
     4426;
     4531;
     4652;
     4777;
     4879;
     4968;
     5059;
     5160];
j = ceil(i/5)+730; %indexes in pbit

qp      = data(i,2);
qback   = data(i,5);
qc      = data(i, 38);
pp      = data(i, 16);
pc      = data(i, 36);
pbit    = pbitMeas(j,1);
phydro  = 263.6061;

%% 5 functions
c1 = 0;
c2 = 500;
c3 = 1000;
c4 = 1500;
c5 = 2000;
c = [c1, c2, c3, c4, c5];
mu1 = 500;
mu2 = 500;
mu3 = 500;
mu4 = 500;
mu5 = 500;
mu = [mu1, mu2, mu3, mu4, mu5];
%mu6 = 0.25;

i = 1;
qpSpan = 0:2:2000;
for x=qpSpan
    w1(i) = baseFunc(x, c1, mu1);
    i = i+1;
end

i=1;
for x=qpSpan
    w2(i) = baseFunc(x, c2, mu2);
    i=i+1;
end
i=1;
for x=qpSpan
    w3(i) = baseFunc(x, c3, mu3);
    i=i+1;
end
i=1;
for x=qpSpan
    w4(i) = baseFunc(x, c4, mu4);
    i=i+1;
end
i=1;
for x=qpSpan
    w5(i) = baseFunc(x, c5, mu5);
    i=i+1;
end


wk = w1+w2+w3+w4+w5;
phi1 = w1./wk;
phi2 = w2./wk;
phi3 = w3./wk;
phi4 = w4./wk;
phi5 = w5./wk;


theta1 = 0.1;
theta2 = 3.4;
theta3 = 5.7;
theta4 = 9.6;
theta5 = 15.1;

theta = [theta1, theta2, theta3, theta4, theta5];


Pfric = pbit-pc-phydro;
PfricHat = phi1*theta1 + phi2*theta2+phi3*theta3+ phi4*theta4+ phi5*theta5;



figure
plot(qp, Pfric,'o', qpSpan, PfricHat,'r--');
grid on
ylabel('\phi^T\theta');
xlabel('q_{bit} [ltr/min]');
l = legend('P_{fric}^a', 'P_{fric}^a Approx', 'Location', 'Southeast');
set(l, 'FontSize', 8);
axis([0 2000 0 16])
set(gcf, 'PaperUnits', 'centimeters');
set(gcf, 'PaperSize', [15 10]);
set(gcf, 'PaperPosition', [0 0 15 10]);
%pause
%saveas(gcf,'C:\Master\LaTeX\fig\fricApproxImsland','pdf')
%%
figure
plot(qpSpan, phi1,'b', qpSpan, phi2, 'r',qpSpan, phi3, 'k', qpSpan,phi4, 'b',qpSpan, phi5, 'r');%,c, theta./theta, 'o');
grid on;
ylabel('\phi_i');
xlabel('q_{bit} [ltr/min]');
set(gcf, 'PaperUnits', 'centimeters');
set(gcf, 'PaperSize', [15 4]);
set(gcf, 'PaperPosition', [0 0 15 4]);
%saveas(gcf,'C:\Master\LaTeX\fig\fricApproxImslandPhi','pdf')


% subplot(313), plot(qpSpan, w1, 'b', qpSpan, w2, 'r',qpSpan, w3, 'k',qpSpan, w4, 'r',qpSpan, w5, 'b');%,qpSpan, w6, 'r');
% grid on;
% ylabel('\omega_i');
% xlabel('q_p [ltr/min]');

%% 7 functions

c1 = 0;
c2 = 300;
c3 = 500;
c4 = 800;
c5 = 1000;
c6 = 1400;
c7 = 2000;
%c = [c1, c2, c3];
mu1 = 200;
mu2 = 400;
mu3 = 400;
mu4 = 300;
mu5 = 300;
mu6 = 300;
mu7 = 500;

%mu = [mu1, mu2, mu3];

i = 1;
qpSpan = 0:2:2000;
for x=qpSpan
    w1(i) = baseFunc(x, c1, mu1);
    i = i+1;
end

i=1;
for x=qpSpan
    w2(i) = baseFunc(x, c2, mu2);
    i=i+1;
end
i=1;
for x=qpSpan
    w3(i) = baseFunc(x, c3, mu3);
    i=i+1;
end
i=1;
for x=qpSpan
    w3(i) = baseFunc(x, c3, mu3);
    i=i+1;
end
i=1;
for x=qpSpan
    w4(i) = baseFunc(x, c4, mu4);
    i=i+1;
end
i=1;
for x=qpSpan
    w5(i) = baseFunc(x, c5, mu5);
    i=i+1;
end
i=1;
for x=qpSpan
    w6(i) = baseFunc(x, c6, mu6);
    i=i+1;
end
i=1;
for x=qpSpan
    w7(i) = baseFunc(x, c7, mu7);
    i=i+1;
end


wk = w1+w2+w3+w4+w5+w6+w7;
phi1 = w1./wk;
phi2 = w2./wk;
phi3 = w3./wk;
phi4 = w4./wk;
phi5 = w5./wk;
phi6 = w6./wk;
phi7 = w7./wk;


theta1 = 0.3;
theta2 = 8;
theta3 = 6;
theta4 = 7;
theta5 = 8;
theta6 = 9;
theta7 = 10;

%theta = [theta1, theta2, theta3];


Pfric = pbit-pc-phydro;
PfricHat = phi1*theta1 + phi2*theta2+phi3*theta3+ ... 
    phi4*theta4+phi5*theta5+phi6*theta6+phi7*theta7;

figure
subplot(311), plot(qp, Pfric,'o', qpSpan, PfricHat,'r--');
grid on
ylabel('\phi^T\theta');
legend('P_{fric}^a', 'P_{fric}^a Hat');

subplot(312), plot(qpSpan, phi1,'b', qpSpan, phi2, 'r',qpSpan, phi3, 'b', qpSpan,phi4, 'r',qpSpan, phi5, 'b', qpSpan, phi6,'r', qpSpan,phi7,'b');
grid on;
ylabel('\phi_i');

subplot(313), plot(qpSpan, w1, 'b', qpSpan, w2, 'r',qpSpan, w3, 'b',qpSpan, w4, 'r',qpSpan, w5, 'b',qpSpan, w6, 'r',qpSpan, w7, 'b')
grid on;
ylabel('\omega_i');
xlabel('q_p [ltr/min]');


