%%%%
% Some nice constants
%%%%
function tuningPar = getTuningPar()

tuningPar.simLength = 4500;     %Simulation length (sec)
tuningPar.stepSize  = 0.1;      %Stepsize for ode45
tuningPar.qpump     = 1000/6e4; %Flow through mud pump [m^3/s]
tuningPar.qback     = 400/6e4;  %Flow through back pressure pump
tuningPar.qres      = 0.0;      %Flow to/from reservoir
tuningPar.Zc        = 0.1;      %Choke opening

tuningPar.l1        = 1e-5; %Observergain
tuningPar.l2        = 0e-6;
tuningPar.Gamma     = diag([1e5,5e-9]); %Adaption gain
tuningPar.gamma3    = 0e8;

tuningPar.tf        = 50;

tuningPar.Kp        = 1.2;
tuningPar.Ki        = 1;
tuningPar.PcRef     = 6;

% Poly/kalman
tuningPar.H = diag([1,1,1]);

tuningPar.B = diag([1 1e-5 1e-5]);
tuningPar.b = diag([5,1e-3,1e2]);

tuningPar.R = tuningPar.B*tuningPar.B';

%GRIP
tuningPar.gamma0 = 10;
tuningPar.GammaG = 1e5;

tuningPar.GammaGBig = diag([2e3, 1e-9]);
%tuningPar.GammaGBig = diag([7e4, 2e-9]);

tuningPar.theta = [0.1; 3.4; 5.7; 9.6; 15.1];

end