%% Function to run simulation and make plots
clear all;
close all;
clc;

%Get constants
plantPar    = getPlantPar();
tuningPar   = getTuningPar();
initPar     = getInitPar(plantPar, tuningPar);
[qpump qback]= getqpump();

%load qpump2.mat;
%qpump = max(qpump, 100/6e4);

% qpump(1:500)        = 200/6e4;
% qpump(501:1000)     = 800/6e4;
% qpump(1001:1500)    = 1400/6e4;
% qpump(1501:2000)    = 1800/6e4;
% qpump(2001:2500)    = 1400/6e4;
% qpump(2501:3000)    = 800/6e4;
% qpump(3001:3501)    = 200/6e4;
% qpump(2101:2300)    = 300/6e4;
% qpump(2301:2500)    = 800/6e4;
% qpump(2501:2800)    = 1300/6e4;
% qpump(2801:3000)    = 1700/6e4;
% qpump(3001:4001)    = 2000/6e4;
% qpump(1:500) = 300/6e4;
% qpump(501:1000) = 800/6e4;
% qpump(1001:1500) = 1300/6e4;
% qpump(1501:4001) = 1700/6e4;
qback = 0;

basisNumber = 5;

%Run simulation
[Pp, Pc, qbit, qchoke, Pbit, qbitHat, PbitHat, thetaHat, PfricA, PfricAHat]...
    = simulateKaasa(plantPar, tuningPar, initPar, qpump, qback,basisNumber);


%PLOTS
time = 0:tuningPar.simLength;
M = plantPar.Ma + plantPar.Md;
g = plantPar.g;
rhod = plantPar.rhod;
rhoa = plantPar.rhoa;
Fd = plantPar.Fd;
Fa = plantPar.Fa;
F = Fd + Fa;
theta = tuningPar.theta;
%%
% Pressures
figure();
plot(1:length(qpump), Pp(1:length(qpump)),1:length(qpump), 10*Pc(1:length(qpump)));
ylabel('Pressure [Bar]');
xlabel('Time [s]');
legend('Pp', '10*Pc');
axis([0 240 0 350]);
grid on;
set(gcf, 'PaperSize', [15 4]);
set(gcf, 'PaperPosition', [0 0 15 4]);

figure();
plot(1:length(qpump), Pbit(2:length(qpump)+1));
xlabel('Time [s]');
ylabel('Pressure [Bar]');
legend('Pbit');
axis([0 240 200 270]);
grid on;
set(gcf, 'PaperSize', [15 4]);
set(gcf, 'PaperPosition', [0 0 15 4]);
%%
figure();
plot(1:length(qpump), qpump*6e4);
axis([0 240 0 2100])
grid
xlabel('Time [s]');
ylabel('Flow [ltr/min]');
legend('q_p');
set(gcf, 'PaperSize', [15 4]);
set(gcf, 'PaperPosition', [0 0 15 4]);
%%
%Flows
% figure();
% subplot(311), plot(time, qpump(1:time(end)+1)*6e4);%, time, qback*6e4);
% xlabel('Time [s]');
% ylabel('Flow [l/min]');
% legend('qpump');%, 'qback');
% grid on;
% 
% subplot(312), plot(time, qbit*60e3, time, qbitHat*6e4,'r--');
% xlabel('Time [s]');
% ylabel('Flow [l/min]');
% legend('qbit', 'qbit (x(2))');
% grid on;
% 
% subplot(313), plot(time, qchoke*60e3);
% xlabel('Time [s]');
% ylabel('Flow [l/min]');
% legend('qchoke');
% grid on;

%% Estimation

figure();
plot(time, qbit*6e4, time, qbitHat*6e4,'r--');
xlabel('Time [s]');
ylabel('Flow [ltr/min]');
legend('qbit','qbitHat');
grid on;
set(gcf, 'PaperUnits', 'centimeters');
set(gcf, 'PaperSize', [15 4]);
set(gcf, 'PaperPosition', [0 0 15 4]);
%pause
%saveas(gcf,'C:\Master\LaTeX\fig\fricImslandqbit','pdf')
%%
figure();
subplot(511), plot(time, theta(1)*ones(1,tuningPar.simLength+1), time, thetaHat(1,:),'r--');
xlabel('Time [s]');
ylabel('[]');
legend('\theta_1','\theta_1 Hat');
grid on;

subplot(512), plot(time, theta(2)*ones(1,tuningPar.simLength+1), time, thetaHat(2,:),'r--');
xlabel('Time [s]');
ylabel('[]');
legend('\theta_2','\theta_2 Hat');
grid on;

subplot(513), plot(time, theta(3)*ones(1,tuningPar.simLength+1), time, thetaHat(3,:),'r--');
xlabel('Time [s]');
ylabel('[]');
legend('\theta_3','\theta_3 Hat');
grid on;


subplot(514), plot(time, theta(4)*ones(1,tuningPar.simLength+1), time, thetaHat(4,:),'r--');
xlabel('Time [s]');
ylabel('[]');
legend('\theta_4','\theta_4 Hat');
grid on;

subplot(515), plot(time, theta(5)*ones(1,tuningPar.simLength+1), time, thetaHat(5,:),'r--');
xlabel('Time [s]');
ylabel('[]');
legend('\theta_5','\theta_5 Hat');
grid on;
set(gcf, 'PaperUnits', 'centimeters');
set(gcf, 'PaperSize', [15 15]);
set(gcf, 'PaperPosition', [0 0 15 15]);
%pause
%saveas(gcf,'C:\Master\LaTeX\fig\fricImslandThetaAll','pdf')
%% Error
% 
% figure();
% subplot(311), plot(time, qbit-qbitHat);
% xlabel('Time [s]');
% ylabel('Value [?]');
% legend('qbit-qbitHat');
% grid on;
% 
% 
% subplot(312), plot(time, (Fa+Fd)/M*ones(1,tuningPar.simLength+1)-(thetaHat(1,:)));
% xlabel('Time [s]');
% ylabel('Value [?]');
% legend('F-FHat');
% grid on;
% subplot(313), plot(time, 0*ones(1,tuningPar.simLength+1)-(thetaHat(2,:)));
% xlabel('Time [s]');
% ylabel('Value [?]');
% legend('rho-rhoHat');
% grid on;

%% Friction
figure

plot(time, PfricA, time, PfricAHat,'r--', time, PfricA-PfricAHat,'-.');
xlabel('Time [s]');
ylabel('Pressure [bar]');
l = legend('P_{fric}^a', 'P_{fric}^a Hat', 'Error', 'Location', 'SouthWest', 'Orientation','Horizontal');
set(l, 'FontSize',8);
grid on;
set(gcf, 'PaperUnits', 'centimeters');
set(gcf, 'PaperSize', [15 7]);
set(gcf, 'PaperPosition', [0 0 15 7]);
%pause
%saveas(gcf,'C:\Master\LaTeX\fig\fricImslandPfricError','pdf')
%close all
%% 3D plot
clear Pf3dHat
%Pf3dHat = zeros(201,101);
%Pf3d    = zeros(201,101);
phi = getBasisFunc(5);

step = 10;

i = 1;
j = 1;
for t = 0:step:tuningPar.simLength-1
    j = 1;
    for q = 0:step:2000
        Pf3dHat(i,j) = getFriction(q/6e4,thetaHat(:,t+1), phi, 5);
     %   Pf3d(i,j) = getFriction(q/6e4,theta, phi, 5);
        j = j+1;
    end
    i = i+1;
end
%%
figure
%surf(1:20:2000,1:20:4000,Pf3d(2:end,2:end)-Pf3dHat(2:end,2:end));
surf(0:step:2000,0:10*step:tuningPar.simLength-1,Pf3dHat(1:10:end,1:end));

xlabel('Flow [ltr/min]');
ylabel('Time [s]');
zlabel('P_{fric} [Bar]');
axis([0 2000 0 4500 0 15])
set(gcf, 'PaperUnits', 'centimeters');
set(gcf, 'PaperSize', [15 10]);
set(gcf, 'PaperPosition', [0 0 15 10]);
%pause
%saveas(gcf,'C:\Master\LaTeX\fig\fricImsland3D','pdf')
%close all
%% theta when support
t11 = 1:20;
t12 = 335:440;
t21 = 1:1003;
t22 = 2516:3500;
t31 = 503:1503;
t32 = 2029:3004;
t4  = 1004:2515;
t5  = 1504:2029;

figure  
hold on
plot(t11, thetaHat(1,t11),'b--',...
     t21, thetaHat(2,t21),'r--',...
     t31, thetaHat(3,t31),'g--',...
     t4, thetaHat(4,t4),'m--',...
     t5, thetaHat(5,t5),'c--',...
     t12, thetaHat(1,t12),'b--',...
     t22, thetaHat(2,t22),'r--',...
     t32, thetaHat(3,t32),'g--');
legend('\theta_1 Hat','\theta_2 Hat','\theta_3 Hat','\theta_4 Hat','\theta_5 Hat');     

plot(t11, theta(1)*ones(1,length(t11)),'b',...
     t12, theta(1)*ones(1,length(t12)),'b',...
     t21, theta(2)*ones(1,length(t21)),'r',...
     t22, theta(2)*ones(1,length(t22)),'r',... 
     t31, theta(3)*ones(1,length(t31)),'g',...
     t32, theta(3)*ones(1,length(t32)),'g',...
     t4, theta(4)*ones(1,length(t4)),'m',...
     t5, theta(5)*ones(1,length(t5)),'c');
xlabel('Time [s]');
ylabel('[]');
grid on;
set(gcf, 'PaperUnits', 'centimeters');
set(gcf, 'PaperSize', [15 10]);
set(gcf, 'PaperPosition', [0 0 15 10]);
%pause
%saveas(gcf,'C:\Master\LaTeX\fig\fricImslandThetaSuppert','pdf')



%%
clear tt1
clear tt2
clear tt3
clear tt4
clear tt5
g = 1;
h = 1;
j = 1;
k = 1;
l = 1;
for i = 1:length(qbit)
    if(qbit(i) < 500/6e4)
        tt1(g) = i;
        g = g+1;
    end
    if(qbit(i) < 1000/6e4)
        tt2(h) = i;
        h=h+1;
    end
    if(qbit(i) > 500/6e4 && qbit(i) < 1500/6e4)
        tt3(j) = i;
        j=j+1;
    end
    if(qbit(i) > 1000/6e4 && qbit(i) < 2000/6e4)
        tt4(k) = i;
        k=k+1;
    end
    if(qbit(i) > 1500/6e4 && qbit(i) < 2000/6e4)
        tt5(l) = i;
        l=l+1;
    end
end




















