clear all;
load 'fricData.mat';
% Find the pressure curve

i = [1615; %indexes in data
     1680;
     1770;
     1848;
     1929;
     2008;
     2154;
     2220;
     2306;
     2404;
     2498;
     2575;
     2651;
     2721;
     2802;
     2868;
     2957;
     3005;
     3157;
     3228;
     3314;
     3408;
     3524;
     3620;
     3712;
     3851;
     3977;
     4097;
     4219;
     4325;
     4426;
     4531;
     4652;
     4777;
     4879;
     4968;
     5059;
     5160];
j = ceil(i/5)+730; %indexes in pbit

qp      = data(i,2);
qback   = data(i,5);
qc      = data(i, 38);
pp      = data(i, 16);
pc      = data(i, 36);
pbit    = pbitMeas(j,1);
phydro  = 263.6061;
%%

ant = 10;
k = 1;



qpSpan = 0:1:2000;
g = 1;

if(ant == 4)
    c = [0 500 1000 1500 2000 3000];
    theta = [3.1 6 9.7 15];
    for j = qpSpan
        phi1(g) = calcPhi(j,k,1,c);
        phi2(g) = calcPhi(j,k,2,c);
        phi3(g) = calcPhi(j,k,3,c);
        phi4(g) = calcPhi(j,k,4,c);
        g = g+1;
    end

    Pfric = pbit-pc-phydro;
    PfricHat = phi1*theta(1) + phi2*theta(2)+phi3*theta(3)+ phi4*theta(4);

    close all
    figure
    plot(qp, Pfric,'o', qpSpan, PfricHat,'r--');
    grid on
    ylabel('\phi^T\theta');
    xlabel('q_{bit} [ltr/min]');
    legend('P_{fric}^a', 'P_{fric}^a Hat', 'location','southeast');
    axis([0 2000 -2 16])
    set(gcf, 'PaperUnits', 'centimeters');
    set(gcf, 'PaperSize', [15 10]);
    set(gcf, 'PaperPosition', [0 0 15 10]);
  %  pause
  %  saveas(gcf,'C:\Master\LaTeX\fig\fricApprox4Bspline','pdf')


    figure 
    plot(qpSpan, phi1,'b', qpSpan, phi2, 'r',qpSpan, phi3, 'b',...
        qpSpan,phi4, 'r');
    grid on;
    ylabel('\phi_i');
    xlabel('q_{bit} [ltr/min]');
    set(gcf, 'PaperUnits', 'centimeters');
    set(gcf, 'PaperSize', [15 4]);
    set(gcf, 'PaperPosition', [0 0 15 4]);
  %  pause
  %  saveas(gcf,'C:\Master\LaTeX\fig\fricApprox4BsplinePhi','pdf')
  %  close all
end

if(ant == 10)
    
    c = [0 200 400 600 800 1000 1200 1400 1600 1800 2000 2200];
    theta = [1.4 2.6 4.0 5.0 6.0 6.8 8.5 11 13 15.1];
    
    
    for j = qpSpan
        phi1(g) = calcPhi(j,k,1,c);
        phi2(g) = calcPhi(j,k,2,c);
        phi3(g) = calcPhi(j,k,3,c);
        phi4(g) = calcPhi(j,k,4,c);
        phi5(g) = calcPhi(j,k,5,c);
        phi6(g) = calcPhi(j,k,6,c);
        phi7(g) = calcPhi(j,k,7,c);
        phi8(g) = calcPhi(j,k,8,c);
        phi9(g) = calcPhi(j,k,9,c);
        phi10(g) = calcPhi(j,k,10,c);
        g = g+1;
    end

    Pfric = pbit-pc-phydro;
    PfricHat = phi1*theta(1) + phi2*theta(2)+phi3*theta(3)+ phi4*theta(4) +...
         phi5*theta(5) + phi6*theta(6)+phi7*theta(7)+ phi8*theta(8) +...
          phi9*theta(9) + phi10*theta(10);


    figure
    plot(qp, Pfric,'o', qpSpan, PfricHat,'r--');
    grid on
    ylabel('\phi^T\theta');
    xlabel('q_{bit} [ltr/min]');
    legend('P_{fric}^a', 'P_{fric}^a Hat', 'location','southeast');
    axis([0 2000 -2 16])
    set(gcf, 'PaperUnits', 'centimeters');
    set(gcf, 'PaperSize', [15 10]);
    set(gcf, 'PaperPosition', [0 0 15 10]);
    pause
    saveas(gcf,'C:\Master\LaTeX\fig\fricApprox10Bspline','pdf')


    figure
    plot(qpSpan, phi1,'b', qpSpan, phi2, 'r',qpSpan, phi3, 'b',...
        qpSpan,phi4, 'r',qpSpan,phi5, 'b',qpSpan,phi6, 'r',qpSpan,phi7, 'b',...
        qpSpan,phi8, 'r',qpSpan,phi9, 'b',qpSpan,phi10, 'r');
    grid on;
    ylabel('\phi_i');
    xlabel('q_{bit} [ltr/min]');
    set(gcf, 'PaperUnits', 'centimeters');
    set(gcf, 'PaperSize', [15 4]);
    set(gcf, 'PaperPosition', [0 0 15 4]);
  %  pause
  %  saveas(gcf,'C:\Master\LaTeX\fig\fricApprox10BsplinePhi','pdf')

end


