%% Function to run poly. estimation and kalman-filter
clear all;
close all;
clc;

%Get constants
plantPar    = getPlantPar();
tuningPar   = getTuningPar();
initPar     = getInitPar(plantPar, tuningPar);
%[qpump qback]= getqpump(tuningPar.simLength);
%load qpump.mat;
%load qpump2.mat;
%qpump = max(qpump, 100/6e4);
qpump(1:1000) = 1000/6e4;
qpump(1001:4001) = 500/6e4;
qback = 0;

%Run simulation
[PpK, PcK, qbitK, qchokeK, PbitK, xK, xHatK, P1]...
    = simulateKalman(plantPar, tuningPar, initPar, qpump, qback);
[PpP, PcP, qbitP, qchokeP, PbitP, xP, xHatP, P2]...
    = simulatePoly(plantPar, tuningPar, initPar, qpump, qback);

%PLOTS
time = 0:tuningPar.simLength;
M = plantPar.Ma + plantPar.Md;
g = plantPar.g;
rhod = plantPar.rhod;
rhoa = plantPar.rhoa;
Fd = plantPar.Fd;
Fa = plantPar.Fa;
F = Fd + Fa;
H = tuningPar.H;
%% Pressures
% figure();
% subplot(211),plot(time, Pp,time, 10*Pc, time, x(1,:));
% ylabel('Pressure [Bar]');
% xlabel('Time [s]');
% legend('Pp', '10*Pc', 'x(1)');
% grid on;
% 
% 
% subplot(212),plot(time, Pbit);
% xlabel('Time [s]');
% ylabel('Pressure [Bar]');
% legend('Pbit');
% axis([0 tuningPar.simLength 200 250]);
% grid on;
% 
% % Flows
% figure();
% subplot(311), plot(time, qpump*6e4);%, time, qback*6e4);
% xlabel('Time [s]');
% ylabel('Flow [l/min]');
% legend('qpump');%, 'qback');
% grid on;
% 
% subplot(312), plot(time, qbit*60e3, time, x(2,:)*60e3,'r--');
% xlabel('Time [s]');
% ylabel('Flow [l/min]');
% legend('qbit', 'qbit (x(2))');
% grid on;
% 
% subplot(313), plot(time, qchoke*60e3);
% xlabel('Time [s]');
% ylabel('Flow [l/min]');
% legend('qchoke');
% grid on;

%% Estimation

% figure();
% subplot(311), plot(time,PpP);%, time, xHatK(1,:),'r--', time, xHatP(1,:),'k--');
% xlabel('Time [s]');
% ylabel('Value [?]');
% legend('Pp');%, 'xHatK(1)', 'xHatP(1)');
% grid on;
% 
% subplot(312), plot(time, qbitP*6e4, time, xHatP(2,:)*6e4,'r--');%, time, xHatP(2,:)*6e4,'k--');
% xlabel('Time [s]');
% ylabel('Flow [m^3/s]');
% legend('q_{bit}','q_{bit}Hat Kal.', 'q_{bit}Hat Opt.Poly');
% axis([0 tuningPar.simLength+1 0 1100]);
% grid on;
% 
% subplot(313), plot(time, (Fa+Fd)/M*ones(1,tuningPar.simLength+1), time, xHatP(3,:)/M,'r--');%, time, xHatP(3,:)/M,'k--');
% xlabel('Time [s]');
% ylabel('Value [?]');
% legend('\theta','\theta Hat Kal.', '\theta Hat Opt.Poly');
% grid on;

%% Estimation x and xhat

% figure();
% subplot(311), plot(time,xP(1,:), time, xHatP(1,:),'r--', time, xHatP(1,:),'k--');
% xlabel('Time [s]');
% ylabel('Pressure [bar]');
% legend('Pp x_1', 'Pp Hat Kalm.', 'Pp Hat Opt.Poly');
% grid on;
% 
% subplot(312), plot(time, xP(2,:)*6e4, time, xHatP(2,:)*6e4,'r--', time, xHatP(2,:)*6e4,'k--');
% xlabel('Time [s]');
% ylabel('Pressure [bar]');
% legend('q_{bit} x_2', 'q_{bit} Hat Kalm.', 'q_{bit} Hat Opt.Poly');
% grid on;
% 
% subplot(313), plot(time, xP(3,:)/M, time, xHatP(3,:)/M,'r--', time, xHatP(3,:)/M,'k--');
% xlabel('Time [s]');
% ylabel('Value [?]');
% legend('F x_3','F Hat Kalm.', 'F Hat Opt.Poly');
% grid on;

%% Compare states
% figure();
% subplot(311), plot(time, H(1,1)*xK(1,:),'r-',  time, H(1,1)*xP(1,:),'k-');
% xlabel('Time [s]');
% ylabel('Value [?]');
% legend('xK(1)', 'xP(1)');
% grid on;
% 
% subplot(312), plot(time, H(2,2)*xK(2,:)*6e4,'r-', time, H(2,2)*xP(2,:)*6e4,'k-');
% xlabel('Time [s]');
% ylabel('Value [?]');
% legend('xK(2)', 'xP(2)');
% grid on;
% 
% subplot(313), plot(time, H(3,3)*xK(3,:),'r-', time, H(3,3)*xP(3,:),'k-');
% xlabel('Time [s]');
% ylabel('Value [?]');
% legend('xK(3)', 'xP(3)');
% grid on;

%% Til LaTeX
figure();
subplot(211),plot(time, H(2,2)*xP(2,:)*6e4, time, H(2,2)*xHatP(2,:)*6e4,'r--',time, H(2,2)*xHatK(2,:)*6e4,'g-.');
xlabel('Time [s]');
ylabel('Flow [ltr/min]');
legend('q_{bit}', 'q_{bit} Hat Opt.Poly', 'q_{bit} Hat Kalman');
axis([0 tuningPar.simLength+1 0 2000]);
grid on;

%figure();
%subplot(212),plot(time, H(3,3)*xP(3,:)/M, time,
%H(3,3)*xHatP(3,:)/M,'r--',time, H(3,3)*xK(3,:)/M,'k-', time, xHatK(3,:)/M,'g-.');

subplot(212),plot(time, F*ones(1,tuningPar.simLength+1)/M, time, H(3,3)*xHatP(3,:)/M,'r--', time, xHatK(3,:)/M,'g-.');
xlabel('Time [s]');
ylabel('[-]');
legend('\theta_1', '\theta_1 Hat Opt. Poly', '\theta_1 Hat Kalman');
grid on;

