%% Function to run simulation and make plots
clear all;
close all;
clc;

%Get constants
plantPar    = getPlantPar();
tuningPar   = getTuningPar();
initPar     = getInitPar(plantPar, tuningPar);
%[qpump qback]= getqpump(tuningPar.simLength);
load qpump.mat;
qback = 0;
%Run simulation
[Pp, Pc, qbit, qchoke, Pbit, thetaHat, qbitHat, PpDot, PpdotEst]...
    = simulateGripSimple(plantPar, tuningPar, initPar, qpump, qback);

%PLOTS
time = 0:tuningPar.simLength;
M = plantPar.Ma + plantPar.Md;
g = plantPar.g;
rhod = plantPar.rhod;
rhoa = plantPar.rhoa;
Fd = plantPar.Fd;
Fa = plantPar.Fa;

%% Pressures
% figure();
% subplot(211),plot(time, Pp,time, 10*Pc, time, x(1,:));
% ylabel('Pressure [Bar]');
% xlabel('Time [s]');
% legend('Pp', '10*Pc', 'x(1)');
% grid on;
% 
% 
% subplot(212),plot(time, Pbit);
% xlabel('Time [s]');
% ylabel('Pressure [Bar]');
% legend('Pbit');
% axis([0 tuningPar.simLength 200 250]);
% grid on;
% 
% % Flows
% figure();
% subplot(311), plot(time, qpump*6e4);%, time, qback*6e4);
% xlabel('Time [s]');
% ylabel('Flow [l/min]');
% legend('qpump');%, 'qback');
% grid on;
% 
% subplot(312), plot(time, qbit*60e3, time, x(2,:)*60e3,'r--');
% xlabel('Time [s]');
% ylabel('Flow [l/min]');
% legend('qbit', 'qbit (x(2))');
% grid on;
% 
% subplot(313), plot(time, qchoke*60e3);
% xlabel('Time [s]');
% ylabel('Flow [l/min]');
% legend('qchoke');
% grid on;

%% Estimation

figure();
subplot(311), plot(time,Pp);%, time, xHat(1,:),'r--');
xlabel('Time [s]');
ylabel('Pressure [Bar]');
legend('P_p');%, 'xHat(1)');
axis([0 time(end) -5 105]);
grid on;

subplot(312), plot(time, qbit*60e3, time, qbitHat*60e3,'r--');
xlabel('Time [s]');
ylabel('Flow [m^3/s]');
legend('q_{bit}','{q}_{bit}Hat');
grid on;

subplot(313), plot(time, (Fa+Fd)/M*ones(1,tuningPar.simLength+1), time, thetaHat,'r--');
xlabel('Time [s]');
ylabel('Parameter [-]');
l = legend('\theta','\theta Hat');
grid on;

%% Estimation x and xhat

% figure();
% subplot(311), plot(time,x(1,:), time, xHat(1,:),'r--');
% xlabel('Time [s]');
% ylabel('Value [?]');
% legend('x(1)', 'xHat(1)');
% grid on;
% 
% subplot(312), plot(time, x(2,:), time, xHat(2,:),'r--');
% xlabel('Time [s]');
% ylabel('Value [?]');
% legend('x(2)','xHat(2)');
% grid on;
% 
% subplot(313), plot(time, x(3,:), time, xHat(3,:),'r--');
% xlabel('Time [s]');
% ylabel('Value [?]');
% legend('x(3)','xHat(3)');
% grid on;




