%% Function to run simulation and make plots
clear all;
close all;
clc;

%Get constants
plantPar    = getPlantPar();
tuningPar   = getTuningPar();
initPar     = getInitPar(plantPar, tuningPar);
%[qpump qback]= getqpump(tuningPar.simLength);
%load qpump.mat;
%load qpump2.mat;
%qpump = max(qpump, 100/6e4);
% qpump(1:100) = 1800/6e4;
% qpump(101:200) = 1600/6e4;
% qpump(201:300) = 1400/6e4;
% qpump(301:401) = 1300/6e4;
% qpump(401:501) = 1200/6e4;
% qpump(501:601) = 1100/6e4;
% qpump(601:701) = 1000/6e4;
% qpump(701:801) = 500/6e4;
% qpump(801:901) = 1000/6e4;
% qpump(901:4000) = 1200/6e4;
qpump(1:1000) = 1000/6e4;
qpump(1001:4000) = 500/6e4;
qback = 0;

%Run simulation
[Pp, Pc, qbit, qchoke, Pbit, x, xHat, P,xDot]...
    = simulatePoly(plantPar, tuningPar, initPar, qpump, qback);

%PLOTS
time = 0:tuningPar.simLength;
M = plantPar.Ma + plantPar.Md;
g = plantPar.g;
rhod = plantPar.rhod;
rhoa = plantPar.rhoa;
Fd = plantPar.Fd;
Fa = plantPar.Fa;
F = Fd + Fa;
H = tuningPar.H;
%% Pressures
% figure();
% subplot(211),plot(time, Pp,time, 10*Pc, time, x(1,:));
% ylabel('Pressure [Bar]');
% xlabel('Time [s]');
% legend('Pp', '10*Pc', 'x(1)');
% grid on;
% 
% 
% subplot(212),plot(time, Pbit);
% xlabel('Time [s]');
% ylabel('Pressure [Bar]');
% legend('Pbit');
% axis([0 tuningPar.simLength 200 250]);
% grid on;
% 
% % Flows
% figure();
% subplot(311), plot(time, qpump*6e4);%, time, qback*6e4);
% xlabel('Time [s]');
% ylabel('Flow [l/min]');
% legend('qpump');%, 'qback');
% grid on;
% 
% subplot(312), plot(time, qbit*60e3, time, x(2,:)*60e3,'r--');
% xlabel('Time [s]');
% ylabel('Flow [l/min]');
% legend('qbit', 'qbit (x(2))');
% grid on;
% 
% subplot(313), plot(time, qchoke*60e3);
% xlabel('Time [s]');
% ylabel('Flow [l/min]');
% legend('qchoke');
% grid on;

%% Estimation

figure();
subplot(311), plot(time,Pp, time, H(1,1)*xHat(1,:),'r--');%, time, xHatP(1,:),'k--');
xlabel('Time [s]');
ylabel('Pressure [bar]');
legend('p_p', 'p_p Hat');%, 'xHatP(1)');
grid on;

subplot(312), plot(time, qbit*6e4, time, H(2,2)*xHat(2,:)*6e4,'r--');
xlabel('Time [s]');
ylabel('Flow [m^3/s]');
legend('q_{bit}', 'q_{bit}Hat');
axis([0 tuningPar.simLength+1 0 2200]);
grid on;

subplot(313), plot(time, (Fa+Fd)/M*ones(1,tuningPar.simLength+1), time, H(3,3)*xHat(3,:)/M,'r--');
xlabel('Time [s]');
ylabel('Value [?]');
legend('\theta', '\theta Hat');
grid on;

%% Estimation x and xhat

figure();
plot(time,H(1,1)*x(1,:), time, H(1,1)*xHat(1,:),'r--');
xlabel('Time [s]');
ylabel('Pressure [bar]');
legend('Pp x_1', 'Pp Hat Opt.Poly');
axis([0 tuningPar.simLength+1 0 200]);
grid on;

figure();
subplot(211),plot(time, H(2,2)*x(2,:)*6e4, time, H(2,2)*xHat(2,:)*6e4,'r--');
xlabel('Time [s]');
ylabel('Flow [ltr/min]');
legend('q_{bit}', 'q_{bit} Hat');
axis([0 tuningPar.simLength+1 -1000 2000]);
grid on;

%figure();
subplot(212),plot(time, H(3,3)*x(3,:)/M, time, H(3,3)*xHat(3,:)/M,'r--');
xlabel('Time [s]');
ylabel('[-]');
legend('\theta_1', '\theta_1 Hat');
grid on;

%% Compare states
% H = tuningPar.H;
% figure();
% subplot(311), plot(time,H(1,1)*x(1,:),'r-',  time, Pp,'k-');
% xlabel('Time [s]');
% ylabel('Value [?]');
% legend('x(1)', 'Pp');
% grid on;
% 
% subplot(312), plot(time, H(2,2)*x(2,:),'r-', time, qbit,'k-');
% xlabel('Time [s]');
% ylabel('Value [?]');
% legend('x(2)', 'q_{bit}');
% grid on;
% 
% subplot(313), plot(time, H(3,3)*x(3,:),'r-', time, F*ones(1,tuningPar.simLength+1),'k-');
% xlabel('Time [s]');
% ylabel('Value [?]');
% legend('x(3)', 'F');
% grid on;




